; Grukarte II 1.0
;
; Copyright (C) 2010 Paul Wilhelm <paul@mosfetkiller.de>
; http://mosfetkiller.de/?s=improvisiertes&page=19
;
; Modul: main.asm | Hauptprogramm

.include "tn13def.inc"	; ATtiny13-spezifische Definitionen


.def NDELAY = r30

; Interruptvektor
.cseg
.org 0
		rjmp	RESET			; Reset Handler
	reti;rjmp	EXT_INT0_vect	; IRQ0 Handler
		rjmp	PCINT0_vect		; PCINT0 Handler
	reti;rjmp	TIM0_OVF_vect	; Timer0 Overflow Handler
	reti;rjmp	EE_RDY_vect		; EEPROM Ready Handler
	reti;rjmp	ANA_COMP_vect	; Analog Comparator Handler
	reti;rjmp	TIM0_COMPA_vect	; Timer0 CompareA Handler
	reti;rjmp	TIM0_COMPB_vect	; Timer0 CompareB Handler
	reti;rjmp	WATCHDOG_vect	; Watchdog Interrupt Handler
	reti;rjmp	ADC_vect		; ADC Conversion Handler


; PCINT0 Handler (Aufwachpunkt nach dem Power-down Mode)
PCINT0_vect:
	reti


; Initialisierungen
RESET:
	cli

	; Stack
	ldi		r16, low(RAMEND)
	out		SPL, r16

	; Pin Change Interrupt
	ldi		r16, (1 << PCIE)	; Enable
	out		GIMSK, r16

	ldi		r16, (1 << PB1)		; PCINT fr PB1 aktivieren
	out		PCMSK, r16

	; Schlafen legen, bis etwas an PB1 passiert
	rcall	SHUTDOWN


; Hauptprogramm
MAIN:

	; Outputs vorbereiten
	ldi		r16, (1 << PB0) | (1 << PB3) | (1 << PB4)
	out		DDRB, r16


	; Den ganzen Kram 2 mal
	ldi		r22, 2
	NOCHMAL:


	; 14x Lauflicht rechts
	ldi		r20, 14

	ldi		NDELAY, 140	; Geschwindigkeit setzen

	LAUFLICHTR:

		ldi		r16, (1 << PB0)
		out		PORTB, r16
		rcall	DELAY

		ldi		r16, (1 << PB3)
		out		PORTB, r16
		rcall	DELAY

		ldi		r16, (1 << PB4)
		out		PORTB, r16
		rcall	DELAY

		subi	NDELAY, 5

		dec		r20
		brne	LAUFLICHTR


	; 14x Lauflicht links
	ldi		r20, 14

	LAUFLICHTL:
		ldi		r16, (1 << PB4)
		out		PORTB, r16
		rcall	DELAY

		ldi		r16, (1 << PB3)
		out		PORTB, r16
		rcall	DELAY

		ldi		r16, (1 << PB0)
		out		PORTB, r16
		rcall	DELAY

		subi	NDELAY, -5

		dec		r20
		brne	LAUFLICHTL


	dec		r22
	brne	NOCHMAL


	; Alles aus
	ldi		r16, 0
	out		PORTB, r16

	; Schlafen
	rcall	SHUTDOWN

	rjmp	MAIN


DELAY:
	push	r16
	push	r17
	mov		r16, NDELAY
	ldi		r17, 255

	DELAY_LOOP_0:

		DELAY_LOOP_1:
			nop
			dec		r17
			brne	DELAY_LOOP_1

		dec		r16
		brne	DELAY_LOOP_0

	pop		r17
	pop		r16

	reti


; Abschalten (Schlafmodus)
SHUTDOWN:
	push	r16

	sei		; Interrupts an!

	; Ab in den Schlafmodus
	ldi		r16, (1 << SM1) | (1 << SE)	; Power-down Mode
	out		MCUCR, r16

	sleep	; Gute Nacht...

	cli		; Interrupts aus!

	; Und hier geht es nach dem Aufwachen dann auch schon gleich wieder weiter
	pop		r16

	reti
